-- DCS 127 Mod to place in Game folder for proper fonctionnality
--[[ if Mod in user : errors with 
2: attempt to index global 'LockOn_Options' (a nil value)]]--
dofile("./Scripts/Aircrafts/_Common/Cockpit/elements_defs.lua")

SetCustomScale(1.0)

function AddElement(object)
	object.screenspace = ScreenType.SCREENSPACE_TRUE
    object.use_mipfilter = true
    Add(object)
end

local aspect        = LockOn_Options.screen.aspect
local size          = 0.15						
	-- original 0.15  ratio vs aspect of viewport in options.lua
local tex_scale     = 0.25/size
-- local line_width   = (4.5/512)/tex_scale   -- original value 	
	-- this multiplier is for mobile cursors size here is x 2 / original
local line_width    = (9/512)/tex_scale	-- to try 9/512

local roll_stick_lim		        = 130
-- local roll_stick_movement           = 130						
-- Joystick Y axis line length 
local pitch_stick_pos               = 148.3								-- 115	for ka50
local pitch_stick_neg               = 148.3								-- 181.6 for ka50
local rudder_lim	                = 81.5
local k                             = size / roll_stick_lim
local pitch_stick_movement_positive = pitch_stick_pos * k
local pitch_stick_movement_negative = pitch_stick_neg * k
local box_height					= 0.2								-- not in ka50
--[[
    CURR_SCREENSPACE_NONE = 0,
    CURR_SCREENSPACE_HUD_ONLY_VIEW = 1,
    CURR_SCREENSPACE_ARCADE = 2,
--]]

local ds           = 0.05 * size
-- local ds           = 0.05 * size									
	-- multiplier for cursors size 
local collec_shift = 0.3*size
-- local collec_shift = 0.3*size						
		-- collective shift cursor size
local rud_shift    = 0.15*size
-- local rud_shift    = 0.1*size		
		-- rudder cursor size

local orange_mat   = MakeMaterial("",{255,100,0,50})

-- Main window design
base       			= CreateElement "ceMeshPoly"
base.name		    = "base"
base.primitivetype  = "triangles"
base.material       = MakeMaterial("",{0,0,0,100})	-- black_transparent 		
-- base.material       = "ARCADE_4" -- "GREEN_TRANSPARENT"
-- couleur du fond
-- black_transparent background, I hate the whole red original design
base.vertices       = {{-(size + collec_shift + rud_shift + 3.0*line_width + ds), -(box_height )},			-- boxheight not in ka50
                       {-(size + collec_shift + rud_shift + 3.0*line_width + ds),  box_height  }, 
                       { size  + ds                            ,  box_height  },
                       { size  + ds                            , -(box_height )}}   
base.indices        = default_box_indices
-- base.init_pos       = {0,(1 - 1.3*size)}								-- different ka50 base.init_pos       = {0,(1 - 1.5*size)}
base.init_pos       = {0,(1 - 1.3*size)}

						--base.init_pos       = {0,0} 
						--  [ Top = +1 ; center = 0 ; Down = -1 ]
	-- [ Main window position on screen ]
	--[[
	{"screenspace_position",indice,X,Y}  
		CURR_SCREENSPACE_NONE = 0
		CURR_SCREENSPACE_HUD_ONLY_VIEW = 1,
		CURR_SCREENSPACE_ARCADE = 2,
	view ALT F1 		{"screenspace_position",1,X,Y} 
	view F1 			{"screenspace_position",2,X,Y}
	
	X,Y, coordinates for base line (down) of the graphs window, but not a corner: it is just under joystick Y pitch axis for horizontal coordinate, and at the base of window for veritcal one.
	graph window up line is at Y-3*size
	Values I found :
	X : -1 top left ------ 0 center ------- +1 top right ou [ - aspect ; 0 ; + aspect ]
	Y : 0 center of hud ?						 
		+ is above on screen of down screen
		- is below on screen ; -1.6 for down of main 1080 height screen
]]--	
--[[base.controllers    = {{"show"},{"screenspace_position",2,-(aspect - 2*size),0},               -- for ka50
                                {"screenspace_position",1,0,0}}
								
base.controllers    = {{"show"},{"screenspace_position",2,-(aspect - (size+collec_shift  + rud_shift +3.0*line_width + ds)),0},
                                {"screenspace_position",1,0,0}}								
								]]--	
base.controllers    = {{"show"},{"screenspace_position",2,0,-1.6},
								{"screenspace_position",1,0,-1.6}}						
base.h_clip_relation  = h_clip_relations.REWRITE_LEVEL
base.level		      = DEFAULT_LEVEL
AddElement(base)

-- axis X
pitch_scale                = CreateElement "ceTexPoly"
pitch_scale.name		   = "pitch_scale"
pitch_scale.vertices       = {{-pitch_stick_movement_positive   , -line_width},
                              {-pitch_stick_movement_positive   ,  line_width},
                              { pitch_stick_movement_negative   ,  line_width},
                              { pitch_stick_movement_negative   , -line_width}}
pitch_scale.indices		   = default_box_indices
-- pitch_scale.material	   = "ARCADE_3_RED"
-- see DCS World\Mods\aircrafts\Ka-50\Cockpit\Scripts\materials.lua
pitch_scale.material	   = "ARCADE_2_GREY"
-- this is yellow one       
pitch_scale.init_rot       = {90,0,0}
pitch_scale.tex_params	   = {256/512,176.5/512,0.5*tex_scale,2*tex_scale}
pitch_scale.parent_element = base.name
AddElement(pitch_scale)

-- axis Y
roll_scale                = CreateElement "ceTexPoly"
roll_scale.name		      = "roll_scale"
roll_scale.vertices       = {{-size   , -line_width},
                             {-size   ,  line_width},
                             { size   ,  line_width},
                             { size   , -line_width}}
roll_scale.indices		  = default_box_indices
roll_scale.material	      = "ARCADE_2_GREY"
-- this is yellow one 	-- see DCS World\Mods\aircrafts\Ka-50\Cockpit\Scripts\materials.lua
-- roll_scale.material	      = "ARCADE_3_RED"
roll_scale.tex_params	  = {256/512,176.5/512,tex_scale,2*tex_scale}
roll_scale.parent_element = base.name
AddElement(roll_scale)

-- Cursor Stick position
local stick_index_sz           = 0.1 * size
-- multiplier or size of cursor
stick_position                  = CreateElement "ceTexPoly"
stick_position.name             = "stick_position"
stick_position.vertices         = {{-stick_index_sz, -stick_index_sz},
                                   {-stick_index_sz,  stick_index_sz},
                                   { stick_index_sz,  stick_index_sz},
                                   { stick_index_sz, -stick_index_sz}}
stick_position.indices          = default_box_indices
stick_position.material	       = "ARCADE_2_YELLOW"
-- stick_position.material	       = "ARCADE_3_WHITE"
stick_position.tex_params	   = {330/512, 365.5 / 512, 2*tex_scale, 2*tex_scale/0.8}
--[[ stick_position.controllers    = {{"stick_pitch", size*1000/roll_stick_lim,				-- forka50
                                                 size*1000/roll_stick_lim},
                                 {"stick_roll", -size*1000/roll_stick_lim}}
stick_position.controllers    = {{"AP"},{"stick_pitch", size*1000/roll_stick_lim,
                                                 size*1000/roll_stick_lim},
                                 {"stick_roll", -size*1000/roll_stick_lim}} ]]--								 
stick_position.controllers    = {{"AP"},{"stick_pitch", size*1000/roll_stick_lim,
                                                 size*1000/roll_stick_lim},
                                 {"stick_roll", -size*1000/roll_stick_lim}}
stick_position.parent_element = base.name
AddElement(stick_position)

																							-- start new for UH1H not in ka50
stick_position_AP				   = CreateElement "ceTexPoly"
stick_position_AP.name             = "stick_position_AP"
stick_position_AP.vertices         = {{-stick_index_sz, -stick_index_sz},
                                   {-stick_index_sz,  stick_index_sz},
                                   { stick_index_sz,  stick_index_sz},
                                   { stick_index_sz, -stick_index_sz}}
stick_position_AP.indices          = default_box_indices
stick_position_AP.material	       = "ARCADE_2_YELLOW"
-- stick_position_AP.material	       = "ARCADE_3_RED"
stick_position_AP.tex_params	   = {330/512,365.5 / 512,2*tex_scale,2*tex_scale/0.8}
stick_position_AP.controllers    = {{"stick_pitch_AP", size*1000/roll_stick_lim,
                                                 size*1000/roll_stick_lim},
                                 {"stick_roll_AP", -size*1000/roll_stick_lim}}
stick_position_AP.parent_element = base.name
AddElement(stick_position_AP)																							
																							-- end new for UH1H not in ka50
-- Rudder axis
rudder_scale                = Copy(roll_scale)
rudder_scale.init_pos       = {0,-(pitch_stick_movement_positive + 0.1*size)}
AddElement(rudder_scale)

-- Rudder cursor
rudder_index             = Copy(roll_scale)
rudder_index.vertices    = {{-2.0*line_width , -line_width},
                            {-2.0*line_width ,  line_width},
                            { 2.0*line_width ,  line_width},
                            { 2.0*line_width , -line_width}}
rudder_index.controllers = {{"rudder",size*1000/rudder_lim},{"rotate",math.rad(90)}}
rudder_index.parent_element = rudder_scale.name
rudder_index.material	 = "ARCADE_2_YELLOW"		
-- rudder_index.material	       ="ARCADE_3_RED"
AddElement(rudder_index)

																							-- start new for UH1H not in ka50
rudder_scale_AP                = Copy(roll_scale)
rudder_scale_AP.init_pos       = {0,-(pitch_stick_movement_positive + 0.1*size)}
AddElement(rudder_scale_AP)

rudder_index_AP             = Copy(roll_scale)
rudder_index_AP.vertices    = {{-2.0*line_width , -line_width},
                            {-2.0*line_width ,  line_width},
                            { 2.0*line_width ,  line_width},
                            { 2.0*line_width , -line_width}}
rudder_index_AP.controllers = {{"AP"},{"rudder_AP",size*1000/rudder_lim},{"rotate",math.rad(90)}}
rudder_index_AP.parent_element = rudder_scale_AP.name
rudder_index_AP.tex_params	   = {256/512,176.5/512,0.5*tex_scale/3,2*tex_scale/3}
rudder_index_AP.material	       = "ARCADE_2_YELLOW"
--rudder_index_AP.material	       = "ARCADE_3_WHITE"
AddElement(rudder_index_AP)
																							-- end new for UH1H not in ka50

-- Collective axis
local collective_size = pitch_stick_movement_negative

collective_scale             = Copy(pitch_scale)
collective_scale.vertices    = {{0, -line_width},
                                {0,  line_width},
                                {collective_size  ,  line_width},
                                {collective_size, -line_width}}
collective_scale.init_pos    = {-(size + collec_shift),0}
--collective_scale.material=MakeMaterial("",{255,0,255,255})
AddElement(collective_scale)

collective_index             = Copy(roll_scale)
collective_index.vertices    = {{-2.0*line_width , -line_width},
                                {-2.0*line_width ,  line_width},
                                { 2.0*line_width ,  line_width},
                                { 2.0*line_width , -line_width}}
collective_index.controllers = {{"AP"},{"collective",collective_size}}
collective_index.init_rot    = {-90,0,0}
collective_index.tex_params	   = {256/512,176.5/512,0.5*tex_scale/3,2*tex_scale/3}
collective_index.parent_element  = collective_scale.name
collective_index.material="ARCADE_2_PURPLE"
--collective_index.material="ARCADE_3_WHITE"
AddElement(collective_index)

																							-- start new for UH1H not in ka50
local collective_size_AP = pitch_stick_movement_negative																							

collective_scale_AP             = Copy(pitch_scale)
collective_scale_AP.vertices    = {{0, -line_width},
                                {0,  line_width},
                                {collective_size  ,  line_width},
                                {collective_size, -line_width}}
collective_scale_AP.init_pos    = {-(size + collec_shift),0}
AddElement(collective_scale_AP)

collective_index_AP             = Copy(roll_scale)
collective_index_AP.vertices    = {{-2.0*line_width , -line_width},
                                {-2.0*line_width ,  line_width},
                                { 2.0*line_width ,  line_width},
                                { 2.0*line_width , -line_width}}
collective_index_AP.controllers = {{"collective_AP",collective_size_AP}}
collective_index_AP.tex_params	   = {256/512,176.5/512,0.5*tex_scale/3,2*tex_scale/3}
collective_index_AP.init_rot    = {-90,0,0}
collective_index_AP.material="ARCADE_2_PURPLE"
--collective_index_AP.material="ARCADE_3_RED"
collective_index_AP.parent_element  = collective_scale_AP.name
AddElement(collective_index_AP)
																							-- end new for UH1H not in ka50


-- Throttle axe grad
for i = 1,2 do
local rud_sz   = pitch_stick_movement_positive + 0.1*size

local rud = Copy(pitch_scale)
	  rud.material	     = "ARCADE_2_GREY" 
	  -- color for throttle axis center may be modified here
      rud.vertices       = {{ 0      , -line_width},
                            { 0      ,  line_width},
                            { rud_sz   ,  line_width},
                            { rud_sz   , -line_width}}
        
      rud.parent_element = collective_scale.name
      if i == 1 then
      rud.init_pos       =  {-rud_sz, rud_shift}
      else
      rud.init_pos       =  {-rud_sz,-rud_shift}
      end
      rud.init_rot       = {0,0,0}
      AddElement(rud)
 
-- throttle axis 
local tick_50 = Copy(roll_scale)
      if i == 2 then tick_50.vertices    = {{0, -line_width},{0,  line_width},{3.0*line_width ,  line_width},{3.0*line_width , -line_width}}
      else           tick_50.vertices    = {{-3.0*line_width, -line_width},{-3.0*line_width,  line_width},{ 0 ,  line_width},{ 0 , -line_width}}   end
      tick_50.parent_element = rud.name
      tick_50.init_rot       = {90,0,0}
																-- ka50 is tick_50.init_pos       = {(50/120)*rud_sz,0,0}
	  tick_50.init_pos       = {(20/120)*rud_sz,0,0}
	  --tick.material=MakeMaterial("",{255,255,255,255})	  
	  tick_50.material	     = "ARCADE_2_GREY" 
	  -- color for throttle 50% line
      AddElement(tick_50)

local tick_35 = Copy(tick_50)

      if i == 2 then tick_35.vertices    = {{0, -line_width},{0,  line_width},{1.5*line_width ,  line_width},{1.5*line_width , -line_width}}
      else           tick_35.vertices    = {{-1.5*line_width, -line_width},{-1.5*line_width,  line_width},{ 0 ,  line_width},{ 0 , -line_width}}   end
      tick_35.init_pos       = {(13/120)*rud_sz,0,0}
	  --tick.material=MakeMaterial("",{255,255,255,255})	  
	  tick_35.material	     = "ARCADE_2_GREY" 
	  -- color for throttle 35% line   
	  AddElement(tick_35)
      
local tick             = Copy(tick_50)
      tick.init_rot    = {-90,0,0}
														-- ka50 		tick.init_pos    = {0,0,0}	  
      tick.init_pos    = {(20/120)*rud_sz,0,0}
														-- ka50       	tick.controllers = {{"throttle",i,rud_sz}}
      tick.controllers = {{"throttle", i, rud_sz * 100/120, rud_sz * 9/120}}
	  --tick.material="ARCADE_3_RED"
	  -- color for throttle cursor
	  tick.material	     = "ARCADE_2_PURPLE" 	
	  tick.tex_params	   = {256/512,176.5/512,0.5*tex_scale/3,2*tex_scale/3}
      AddElement(tick)
	
																-- start new for UH1H not in ka50																		
local tick_AP             = Copy(tick_50)
      tick_AP.init_rot    = {-90,0,0}
      tick_AP.init_pos    = {(13/120)*rud_sz,0,0}
      tick_AP.controllers = {{"AP"},{"throttle_AP", i, rud_sz * 100/120, rud_sz * 9/120}}
	  tick_AP.material="ARCADE_2_PURPLE"
	  tick_AP.tex_params	   = {256/512,176.5/512,0.5*tex_scale/3,2*tex_scale/3}
      AddElement(tick_AP) 	  
																-- end new for UH1H not in ka50																		
	 
end

																-- no autopilot lines in UH1H as in ka50